# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['BurnAlertArgs', 'BurnAlert']

@pulumi.input_type
class BurnAlertArgs:
    def __init__(__self__, *,
                 dataset: pulumi.Input[str],
                 slo_id: pulumi.Input[str],
                 alert_type: Optional[pulumi.Input[str]] = None,
                 budget_rate_decrease_percent: Optional[pulumi.Input[float]] = None,
                 budget_rate_window_minutes: Optional[pulumi.Input[int]] = None,
                 exhaustion_minutes: Optional[pulumi.Input[int]] = None,
                 recipients: Optional[pulumi.Input[Sequence[pulumi.Input['BurnAlertRecipientArgs']]]] = None):
        """
        The set of arguments for constructing a BurnAlert resource.
        :param pulumi.Input[str] dataset: The dataset this burn alert is associated with.
        :param pulumi.Input[str] slo_id: ID of the SLO this burn alert is associated with.
        :param pulumi.Input[str] alert_type: Type of the burn alert. Valid values are `exhaustion_time` and `budget_rate`. 
               Defaults to `exhaustion_time`.
        :param pulumi.Input[float] budget_rate_decrease_percent: The percent the budget has decreased over the budget rate window.
               The alert will fire when this budget decrease threshold is reached.
               Must be between 0.0001% and 100%, with no more than 4 numbers past the decimal point.
               Required when `alert_type` is `budget_rate`.
               Must not be provided when `alert_type` is `exhaustion_time`.
        :param pulumi.Input[int] budget_rate_window_minutes: The time period, in minutes, over which a budget rate will be calculated. 
               Must be between 60 and the associated SLO's time period.
               Required when `alert_type` is `budget_rate`.
               Must not be provided when `alert_type` is `exhaustion_time`.
        :param pulumi.Input[int] exhaustion_minutes: The amount of time, in minutes, remaining before the SLO's error budget will be exhausted and 
               the alert will fire.
               Must be 0 or greater.
               Required when `alert_type` is `exhaustion_time`.
               Must not be provided when `alert_type` is `budget_rate`.
        :param pulumi.Input[Sequence[pulumi.Input['BurnAlertRecipientArgs']]] recipients: Zero or more configuration blocks (described below) with the recipients to notify when the alert fires.
        """
        pulumi.set(__self__, "dataset", dataset)
        pulumi.set(__self__, "slo_id", slo_id)
        if alert_type is not None:
            pulumi.set(__self__, "alert_type", alert_type)
        if budget_rate_decrease_percent is not None:
            pulumi.set(__self__, "budget_rate_decrease_percent", budget_rate_decrease_percent)
        if budget_rate_window_minutes is not None:
            pulumi.set(__self__, "budget_rate_window_minutes", budget_rate_window_minutes)
        if exhaustion_minutes is not None:
            pulumi.set(__self__, "exhaustion_minutes", exhaustion_minutes)
        if recipients is not None:
            pulumi.set(__self__, "recipients", recipients)

    @property
    @pulumi.getter
    def dataset(self) -> pulumi.Input[str]:
        """
        The dataset this burn alert is associated with.
        """
        return pulumi.get(self, "dataset")

    @dataset.setter
    def dataset(self, value: pulumi.Input[str]):
        pulumi.set(self, "dataset", value)

    @property
    @pulumi.getter(name="sloId")
    def slo_id(self) -> pulumi.Input[str]:
        """
        ID of the SLO this burn alert is associated with.
        """
        return pulumi.get(self, "slo_id")

    @slo_id.setter
    def slo_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "slo_id", value)

    @property
    @pulumi.getter(name="alertType")
    def alert_type(self) -> Optional[pulumi.Input[str]]:
        """
        Type of the burn alert. Valid values are `exhaustion_time` and `budget_rate`. 
        Defaults to `exhaustion_time`.
        """
        return pulumi.get(self, "alert_type")

    @alert_type.setter
    def alert_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "alert_type", value)

    @property
    @pulumi.getter(name="budgetRateDecreasePercent")
    def budget_rate_decrease_percent(self) -> Optional[pulumi.Input[float]]:
        """
        The percent the budget has decreased over the budget rate window.
        The alert will fire when this budget decrease threshold is reached.
        Must be between 0.0001% and 100%, with no more than 4 numbers past the decimal point.
        Required when `alert_type` is `budget_rate`.
        Must not be provided when `alert_type` is `exhaustion_time`.
        """
        return pulumi.get(self, "budget_rate_decrease_percent")

    @budget_rate_decrease_percent.setter
    def budget_rate_decrease_percent(self, value: Optional[pulumi.Input[float]]):
        pulumi.set(self, "budget_rate_decrease_percent", value)

    @property
    @pulumi.getter(name="budgetRateWindowMinutes")
    def budget_rate_window_minutes(self) -> Optional[pulumi.Input[int]]:
        """
        The time period, in minutes, over which a budget rate will be calculated. 
        Must be between 60 and the associated SLO's time period.
        Required when `alert_type` is `budget_rate`.
        Must not be provided when `alert_type` is `exhaustion_time`.
        """
        return pulumi.get(self, "budget_rate_window_minutes")

    @budget_rate_window_minutes.setter
    def budget_rate_window_minutes(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "budget_rate_window_minutes", value)

    @property
    @pulumi.getter(name="exhaustionMinutes")
    def exhaustion_minutes(self) -> Optional[pulumi.Input[int]]:
        """
        The amount of time, in minutes, remaining before the SLO's error budget will be exhausted and 
        the alert will fire.
        Must be 0 or greater.
        Required when `alert_type` is `exhaustion_time`.
        Must not be provided when `alert_type` is `budget_rate`.
        """
        return pulumi.get(self, "exhaustion_minutes")

    @exhaustion_minutes.setter
    def exhaustion_minutes(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "exhaustion_minutes", value)

    @property
    @pulumi.getter
    def recipients(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['BurnAlertRecipientArgs']]]]:
        """
        Zero or more configuration blocks (described below) with the recipients to notify when the alert fires.
        """
        return pulumi.get(self, "recipients")

    @recipients.setter
    def recipients(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['BurnAlertRecipientArgs']]]]):
        pulumi.set(self, "recipients", value)


@pulumi.input_type
class _BurnAlertState:
    def __init__(__self__, *,
                 alert_type: Optional[pulumi.Input[str]] = None,
                 budget_rate_decrease_percent: Optional[pulumi.Input[float]] = None,
                 budget_rate_window_minutes: Optional[pulumi.Input[int]] = None,
                 dataset: Optional[pulumi.Input[str]] = None,
                 exhaustion_minutes: Optional[pulumi.Input[int]] = None,
                 recipients: Optional[pulumi.Input[Sequence[pulumi.Input['BurnAlertRecipientArgs']]]] = None,
                 slo_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering BurnAlert resources.
        :param pulumi.Input[str] alert_type: Type of the burn alert. Valid values are `exhaustion_time` and `budget_rate`. 
               Defaults to `exhaustion_time`.
        :param pulumi.Input[float] budget_rate_decrease_percent: The percent the budget has decreased over the budget rate window.
               The alert will fire when this budget decrease threshold is reached.
               Must be between 0.0001% and 100%, with no more than 4 numbers past the decimal point.
               Required when `alert_type` is `budget_rate`.
               Must not be provided when `alert_type` is `exhaustion_time`.
        :param pulumi.Input[int] budget_rate_window_minutes: The time period, in minutes, over which a budget rate will be calculated. 
               Must be between 60 and the associated SLO's time period.
               Required when `alert_type` is `budget_rate`.
               Must not be provided when `alert_type` is `exhaustion_time`.
        :param pulumi.Input[str] dataset: The dataset this burn alert is associated with.
        :param pulumi.Input[int] exhaustion_minutes: The amount of time, in minutes, remaining before the SLO's error budget will be exhausted and 
               the alert will fire.
               Must be 0 or greater.
               Required when `alert_type` is `exhaustion_time`.
               Must not be provided when `alert_type` is `budget_rate`.
        :param pulumi.Input[Sequence[pulumi.Input['BurnAlertRecipientArgs']]] recipients: Zero or more configuration blocks (described below) with the recipients to notify when the alert fires.
        :param pulumi.Input[str] slo_id: ID of the SLO this burn alert is associated with.
        """
        if alert_type is not None:
            pulumi.set(__self__, "alert_type", alert_type)
        if budget_rate_decrease_percent is not None:
            pulumi.set(__self__, "budget_rate_decrease_percent", budget_rate_decrease_percent)
        if budget_rate_window_minutes is not None:
            pulumi.set(__self__, "budget_rate_window_minutes", budget_rate_window_minutes)
        if dataset is not None:
            pulumi.set(__self__, "dataset", dataset)
        if exhaustion_minutes is not None:
            pulumi.set(__self__, "exhaustion_minutes", exhaustion_minutes)
        if recipients is not None:
            pulumi.set(__self__, "recipients", recipients)
        if slo_id is not None:
            pulumi.set(__self__, "slo_id", slo_id)

    @property
    @pulumi.getter(name="alertType")
    def alert_type(self) -> Optional[pulumi.Input[str]]:
        """
        Type of the burn alert. Valid values are `exhaustion_time` and `budget_rate`. 
        Defaults to `exhaustion_time`.
        """
        return pulumi.get(self, "alert_type")

    @alert_type.setter
    def alert_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "alert_type", value)

    @property
    @pulumi.getter(name="budgetRateDecreasePercent")
    def budget_rate_decrease_percent(self) -> Optional[pulumi.Input[float]]:
        """
        The percent the budget has decreased over the budget rate window.
        The alert will fire when this budget decrease threshold is reached.
        Must be between 0.0001% and 100%, with no more than 4 numbers past the decimal point.
        Required when `alert_type` is `budget_rate`.
        Must not be provided when `alert_type` is `exhaustion_time`.
        """
        return pulumi.get(self, "budget_rate_decrease_percent")

    @budget_rate_decrease_percent.setter
    def budget_rate_decrease_percent(self, value: Optional[pulumi.Input[float]]):
        pulumi.set(self, "budget_rate_decrease_percent", value)

    @property
    @pulumi.getter(name="budgetRateWindowMinutes")
    def budget_rate_window_minutes(self) -> Optional[pulumi.Input[int]]:
        """
        The time period, in minutes, over which a budget rate will be calculated. 
        Must be between 60 and the associated SLO's time period.
        Required when `alert_type` is `budget_rate`.
        Must not be provided when `alert_type` is `exhaustion_time`.
        """
        return pulumi.get(self, "budget_rate_window_minutes")

    @budget_rate_window_minutes.setter
    def budget_rate_window_minutes(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "budget_rate_window_minutes", value)

    @property
    @pulumi.getter
    def dataset(self) -> Optional[pulumi.Input[str]]:
        """
        The dataset this burn alert is associated with.
        """
        return pulumi.get(self, "dataset")

    @dataset.setter
    def dataset(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "dataset", value)

    @property
    @pulumi.getter(name="exhaustionMinutes")
    def exhaustion_minutes(self) -> Optional[pulumi.Input[int]]:
        """
        The amount of time, in minutes, remaining before the SLO's error budget will be exhausted and 
        the alert will fire.
        Must be 0 or greater.
        Required when `alert_type` is `exhaustion_time`.
        Must not be provided when `alert_type` is `budget_rate`.
        """
        return pulumi.get(self, "exhaustion_minutes")

    @exhaustion_minutes.setter
    def exhaustion_minutes(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "exhaustion_minutes", value)

    @property
    @pulumi.getter
    def recipients(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['BurnAlertRecipientArgs']]]]:
        """
        Zero or more configuration blocks (described below) with the recipients to notify when the alert fires.
        """
        return pulumi.get(self, "recipients")

    @recipients.setter
    def recipients(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['BurnAlertRecipientArgs']]]]):
        pulumi.set(self, "recipients", value)

    @property
    @pulumi.getter(name="sloId")
    def slo_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of the SLO this burn alert is associated with.
        """
        return pulumi.get(self, "slo_id")

    @slo_id.setter
    def slo_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "slo_id", value)


class BurnAlert(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 alert_type: Optional[pulumi.Input[str]] = None,
                 budget_rate_decrease_percent: Optional[pulumi.Input[float]] = None,
                 budget_rate_window_minutes: Optional[pulumi.Input[int]] = None,
                 dataset: Optional[pulumi.Input[str]] = None,
                 exhaustion_minutes: Optional[pulumi.Input[int]] = None,
                 recipients: Optional[pulumi.Input[Sequence[pulumi.Input[Union['BurnAlertRecipientArgs', 'BurnAlertRecipientArgsDict']]]]] = None,
                 slo_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        ## # Resource: BurnAlert

        Creates a burn alert.

        For more information about burn alerts,
        check out [Define Burn Alerts](https://docs.honeycomb.io/working-with-your-data/slos/burn-alerts).

        ## Example Usage

        ### Basic Example - Exhaustion Time Burn Alert
        ```python
        import pulumi
        import thejokersthief-pulumi-honeycomb as honeycomb

        config = pulumi.Config()
        dataset = config.require("dataset")
        slo_id = config.require("sloId")
        example_alert = honeycomb.BurnAlert("exampleAlert",
            alert_type="exhaustion_time",
            exhaustion_minutes=480,
            dataset=dataset,
            slo_id=slo_id,
            recipients=[
                {
                    "type": "email",
                    "target": "hello@example.com",
                },
                {
                    "type": "slack",
                    "target": "#example-channel",
                },
            ])
        ```

        ### Basic Example - Budget Rate Burn Alert
        ```python
        import pulumi
        import thejokersthief-pulumi-honeycomb as honeycomb

        config = pulumi.Config()
        dataset = config.require("dataset")
        slo_id = config.require("sloId")
        example_alert = honeycomb.BurnAlert("exampleAlert",
            alert_type="budget_rate",
            budget_rate_window_minutes=480,
            budget_rate_decrease_percent=1,
            dataset=dataset,
            slo_id=slo_id,
            recipients=[{
                "type": "webhook",
                "target": "name of the webhook",
            }])
        ```

        ## Import

        Burn alerts can be imported using a combination of the dataset name and their ID, e.g.

        ```sh
        $ pulumi import honeycomb:index/burnAlert:BurnAlert my_alert my-dataset/bj9BwOb1uKz
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] alert_type: Type of the burn alert. Valid values are `exhaustion_time` and `budget_rate`. 
               Defaults to `exhaustion_time`.
        :param pulumi.Input[float] budget_rate_decrease_percent: The percent the budget has decreased over the budget rate window.
               The alert will fire when this budget decrease threshold is reached.
               Must be between 0.0001% and 100%, with no more than 4 numbers past the decimal point.
               Required when `alert_type` is `budget_rate`.
               Must not be provided when `alert_type` is `exhaustion_time`.
        :param pulumi.Input[int] budget_rate_window_minutes: The time period, in minutes, over which a budget rate will be calculated. 
               Must be between 60 and the associated SLO's time period.
               Required when `alert_type` is `budget_rate`.
               Must not be provided when `alert_type` is `exhaustion_time`.
        :param pulumi.Input[str] dataset: The dataset this burn alert is associated with.
        :param pulumi.Input[int] exhaustion_minutes: The amount of time, in minutes, remaining before the SLO's error budget will be exhausted and 
               the alert will fire.
               Must be 0 or greater.
               Required when `alert_type` is `exhaustion_time`.
               Must not be provided when `alert_type` is `budget_rate`.
        :param pulumi.Input[Sequence[pulumi.Input[Union['BurnAlertRecipientArgs', 'BurnAlertRecipientArgsDict']]]] recipients: Zero or more configuration blocks (described below) with the recipients to notify when the alert fires.
        :param pulumi.Input[str] slo_id: ID of the SLO this burn alert is associated with.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: BurnAlertArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        ## # Resource: BurnAlert

        Creates a burn alert.

        For more information about burn alerts,
        check out [Define Burn Alerts](https://docs.honeycomb.io/working-with-your-data/slos/burn-alerts).

        ## Example Usage

        ### Basic Example - Exhaustion Time Burn Alert
        ```python
        import pulumi
        import thejokersthief-pulumi-honeycomb as honeycomb

        config = pulumi.Config()
        dataset = config.require("dataset")
        slo_id = config.require("sloId")
        example_alert = honeycomb.BurnAlert("exampleAlert",
            alert_type="exhaustion_time",
            exhaustion_minutes=480,
            dataset=dataset,
            slo_id=slo_id,
            recipients=[
                {
                    "type": "email",
                    "target": "hello@example.com",
                },
                {
                    "type": "slack",
                    "target": "#example-channel",
                },
            ])
        ```

        ### Basic Example - Budget Rate Burn Alert
        ```python
        import pulumi
        import thejokersthief-pulumi-honeycomb as honeycomb

        config = pulumi.Config()
        dataset = config.require("dataset")
        slo_id = config.require("sloId")
        example_alert = honeycomb.BurnAlert("exampleAlert",
            alert_type="budget_rate",
            budget_rate_window_minutes=480,
            budget_rate_decrease_percent=1,
            dataset=dataset,
            slo_id=slo_id,
            recipients=[{
                "type": "webhook",
                "target": "name of the webhook",
            }])
        ```

        ## Import

        Burn alerts can be imported using a combination of the dataset name and their ID, e.g.

        ```sh
        $ pulumi import honeycomb:index/burnAlert:BurnAlert my_alert my-dataset/bj9BwOb1uKz
        ```

        :param str resource_name: The name of the resource.
        :param BurnAlertArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(BurnAlertArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 alert_type: Optional[pulumi.Input[str]] = None,
                 budget_rate_decrease_percent: Optional[pulumi.Input[float]] = None,
                 budget_rate_window_minutes: Optional[pulumi.Input[int]] = None,
                 dataset: Optional[pulumi.Input[str]] = None,
                 exhaustion_minutes: Optional[pulumi.Input[int]] = None,
                 recipients: Optional[pulumi.Input[Sequence[pulumi.Input[Union['BurnAlertRecipientArgs', 'BurnAlertRecipientArgsDict']]]]] = None,
                 slo_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = BurnAlertArgs.__new__(BurnAlertArgs)

            __props__.__dict__["alert_type"] = alert_type
            __props__.__dict__["budget_rate_decrease_percent"] = budget_rate_decrease_percent
            __props__.__dict__["budget_rate_window_minutes"] = budget_rate_window_minutes
            if dataset is None and not opts.urn:
                raise TypeError("Missing required property 'dataset'")
            __props__.__dict__["dataset"] = dataset
            __props__.__dict__["exhaustion_minutes"] = exhaustion_minutes
            __props__.__dict__["recipients"] = recipients
            if slo_id is None and not opts.urn:
                raise TypeError("Missing required property 'slo_id'")
            __props__.__dict__["slo_id"] = slo_id
        super(BurnAlert, __self__).__init__(
            'honeycomb:index/burnAlert:BurnAlert',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            alert_type: Optional[pulumi.Input[str]] = None,
            budget_rate_decrease_percent: Optional[pulumi.Input[float]] = None,
            budget_rate_window_minutes: Optional[pulumi.Input[int]] = None,
            dataset: Optional[pulumi.Input[str]] = None,
            exhaustion_minutes: Optional[pulumi.Input[int]] = None,
            recipients: Optional[pulumi.Input[Sequence[pulumi.Input[Union['BurnAlertRecipientArgs', 'BurnAlertRecipientArgsDict']]]]] = None,
            slo_id: Optional[pulumi.Input[str]] = None) -> 'BurnAlert':
        """
        Get an existing BurnAlert resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] alert_type: Type of the burn alert. Valid values are `exhaustion_time` and `budget_rate`. 
               Defaults to `exhaustion_time`.
        :param pulumi.Input[float] budget_rate_decrease_percent: The percent the budget has decreased over the budget rate window.
               The alert will fire when this budget decrease threshold is reached.
               Must be between 0.0001% and 100%, with no more than 4 numbers past the decimal point.
               Required when `alert_type` is `budget_rate`.
               Must not be provided when `alert_type` is `exhaustion_time`.
        :param pulumi.Input[int] budget_rate_window_minutes: The time period, in minutes, over which a budget rate will be calculated. 
               Must be between 60 and the associated SLO's time period.
               Required when `alert_type` is `budget_rate`.
               Must not be provided when `alert_type` is `exhaustion_time`.
        :param pulumi.Input[str] dataset: The dataset this burn alert is associated with.
        :param pulumi.Input[int] exhaustion_minutes: The amount of time, in minutes, remaining before the SLO's error budget will be exhausted and 
               the alert will fire.
               Must be 0 or greater.
               Required when `alert_type` is `exhaustion_time`.
               Must not be provided when `alert_type` is `budget_rate`.
        :param pulumi.Input[Sequence[pulumi.Input[Union['BurnAlertRecipientArgs', 'BurnAlertRecipientArgsDict']]]] recipients: Zero or more configuration blocks (described below) with the recipients to notify when the alert fires.
        :param pulumi.Input[str] slo_id: ID of the SLO this burn alert is associated with.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _BurnAlertState.__new__(_BurnAlertState)

        __props__.__dict__["alert_type"] = alert_type
        __props__.__dict__["budget_rate_decrease_percent"] = budget_rate_decrease_percent
        __props__.__dict__["budget_rate_window_minutes"] = budget_rate_window_minutes
        __props__.__dict__["dataset"] = dataset
        __props__.__dict__["exhaustion_minutes"] = exhaustion_minutes
        __props__.__dict__["recipients"] = recipients
        __props__.__dict__["slo_id"] = slo_id
        return BurnAlert(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="alertType")
    def alert_type(self) -> pulumi.Output[str]:
        """
        Type of the burn alert. Valid values are `exhaustion_time` and `budget_rate`. 
        Defaults to `exhaustion_time`.
        """
        return pulumi.get(self, "alert_type")

    @property
    @pulumi.getter(name="budgetRateDecreasePercent")
    def budget_rate_decrease_percent(self) -> pulumi.Output[Optional[float]]:
        """
        The percent the budget has decreased over the budget rate window.
        The alert will fire when this budget decrease threshold is reached.
        Must be between 0.0001% and 100%, with no more than 4 numbers past the decimal point.
        Required when `alert_type` is `budget_rate`.
        Must not be provided when `alert_type` is `exhaustion_time`.
        """
        return pulumi.get(self, "budget_rate_decrease_percent")

    @property
    @pulumi.getter(name="budgetRateWindowMinutes")
    def budget_rate_window_minutes(self) -> pulumi.Output[Optional[int]]:
        """
        The time period, in minutes, over which a budget rate will be calculated. 
        Must be between 60 and the associated SLO's time period.
        Required when `alert_type` is `budget_rate`.
        Must not be provided when `alert_type` is `exhaustion_time`.
        """
        return pulumi.get(self, "budget_rate_window_minutes")

    @property
    @pulumi.getter
    def dataset(self) -> pulumi.Output[str]:
        """
        The dataset this burn alert is associated with.
        """
        return pulumi.get(self, "dataset")

    @property
    @pulumi.getter(name="exhaustionMinutes")
    def exhaustion_minutes(self) -> pulumi.Output[Optional[int]]:
        """
        The amount of time, in minutes, remaining before the SLO's error budget will be exhausted and 
        the alert will fire.
        Must be 0 or greater.
        Required when `alert_type` is `exhaustion_time`.
        Must not be provided when `alert_type` is `budget_rate`.
        """
        return pulumi.get(self, "exhaustion_minutes")

    @property
    @pulumi.getter
    def recipients(self) -> pulumi.Output[Optional[Sequence['outputs.BurnAlertRecipient']]]:
        """
        Zero or more configuration blocks (described below) with the recipients to notify when the alert fires.
        """
        return pulumi.get(self, "recipients")

    @property
    @pulumi.getter(name="sloId")
    def slo_id(self) -> pulumi.Output[str]:
        """
        ID of the SLO this burn alert is associated with.
        """
        return pulumi.get(self, "slo_id")

